/*
 *John's City Services Generation Program
 *
 *This program calculates the services available 
 *in a city based on the city population.
 *
 *Percentage chances for each service per population block
 *are taken from the World Builder's Guidebook, an AD&D
 *accessory by Richard Baker, and are used without permission.
 *
 *This program was written by John Reese, jsreese@mit.edu
 *<jsreese@alum.mit.edu> after 6/99
 *
 *Distribute freely, and please let me know of any improvements
 *you can make!
 */

#include <stdio.h>

#define SERVICES 67
#define MAXSTRING 100

/*Enumerate the services*/

#define almshouse 0
#define baker 1
#define boardinghouse 2
#define brewer 3
#define butcher 4
#define cheesemaker 5
#define grocer 6
#define hostel 7
#define inn 8
#define provisioner 9
#define tavern 10
#define vintner 11
#define blacksmith 12
#define trader 13
#define cobbler 14
#define cooper 15
#define leatherworker 16
#define mason 17
#define miller 18
#define potter 19
#define tanner 20
#define weaver 21
#define woodworker 22
#define apothecary 23
#define armorer 24
#define bookbinder 25
#define bowyer 26
#define clockmaker 27
#define chandler 28
#define dyer 29
#define clothier 30
#define furrier 31
#define glassblower 32
#define herbalist 33
#define jeweler 34
#define locksmith 35
#define seamstress 36
#define specialtysmith 37
#define tilemaker 38
#define weaponsmith 39
#define boatforhire 40
#define carter 41
#define cartwright 42
#define porter 43
#define saddler 44
#define shipwright 45
#define stable 46
#define alchemist 47
#define assassin 48
#define astrologer 49
#define barber 50
#define barrister 51
#define burgler 52
#define dragoman 53
#define engineer 54
#define fence 55
#define healer 56
#define interpreter 57
#define laborer 58
#define leech 59
#define linkboy 60
#define minstrel 61
#define navigator 62
#define priest 63
#define sage 64
#define scribe 65
#define wizard 66

int main(void)
{
  int services[SERVICES] = {0};
  int pop_blocks, n, i, j, k, m, o, p, q,  max, population;
  char agg, hill, wine, graze, port, river, wood, village;
  float service_chance[SERVICES] = {0};
  float v_size;
  char c, type, name[MAXSTRING];
  FILE *ofp;
  float rand;

/*Enter information about the city*/

  n = 0;
  printf("%s\n\n%s", 
	 "This program will determine the services available in a city.",
	 "Please enter the city name: ");
  for (n = 0; (c = getchar()) != '\n'; ++n) {
     name[n] = c;
  }
  name[n] = '\0';
  printf("\n%s", "Please enter the city population: ");
  scanf("%d", &population);
  while ((c = getchar()) != '\n') {
  }
  printf("\n%s%s%s\n%s", "Is ", name, " in an area of heavy agriculture?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    agg = c;
  }
  printf("\n%s%s%s\n%s", "Is ", name, " in wine country?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    wine = c;
  }
  printf("\n%s%s%s\n%s", "Is ", name, " in hills or mountains?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    hill = c;
  }
  printf("\n%s%s%s\n%s", "Is ", name, " in an area of herding or grazing?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    graze = c;
  }
  printf("\n%s%s%s\n%s", "Is ", name, " in a forest or woodlands?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    wood = c;
  }
  printf("\n%s%s%s\n%s", "Is ", name, " a port city?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    port = c;
  }
  printf("\n%s%s%s\n%s", "Is ", name, " along a river?",
	 "Please enter y or n: ");
  while ((c = getchar()) != '\n') {
    river = c;
  }

/*Test the values of the environment modifiers
 *
 * printf("\n\n%s%d", "Population = ", population);
 * printf("\n%s%c", "agg = ", agg);
 * printf("\n%s%c", "wine = ", wine);
 * printf("\n%s%c", "hill = ", hill);
 * printf("\n%s%c", "graze = ", graze);
 * printf("\n%s%c", "wood = ", wood);
 * printf("\n%s%c", "port = ", port);
 * printf("\n%s%c\n", "river = ", river);
 */

/*Initialize the service chance array*/

  service_chance[almshouse] = 0.1;
  service_chance[baker] = 0.33;
  service_chance[boardinghouse] = 0.25;
  service_chance[brewer] = 0.33;
  service_chance[butcher] = 0.25;
  service_chance[cheesemaker] = 0.16;
  service_chance[grocer] = 0.5;
  service_chance[hostel] = 0.16;
  service_chance[inn] = 0.66;
  service_chance[provisioner] = 0.25;
  service_chance[tavern] = 1;
  service_chance[vintner] = 0.1;
  service_chance[blacksmith] = 1;
  service_chance[trader] = 1;
  service_chance[cobbler] = 1;
  service_chance[cooper] = 0.66;
  service_chance[leatherworker] = 0.66;
  service_chance[mason] = 0.5;
  service_chance[miller] = 0.5;
  service_chance[potter] = 0.25;
  service_chance[tanner] = 0.33;
  service_chance[weaver] = 0.25;
  service_chance[woodworker] = 1;
  service_chance[apothecary] = 0.08;
  service_chance[armorer] = 0.16;
  service_chance[bookbinder] = 0.1;
  service_chance[bowyer] = 0.33;
  service_chance[clockmaker] = 0.05;
  service_chance[chandler] = 0.16;
  service_chance[dyer] = 0.16;
  service_chance[clothier] = 0.1;
  service_chance[furrier] = 0.1;
  service_chance[glassblower] = 0.1;
  service_chance[herbalist] = 0.05;
  service_chance[jeweler] = 0.08;
  service_chance[locksmith] = 0.08;
  service_chance[seamstress] = 0.33;
  service_chance[specialtysmith] = 0.16;
  service_chance[tilemaker] = 0.16;
  service_chance[weaponsmith] = 0.25;
  service_chance[boatforhire] = 0.5;
  service_chance[carter] = 1;
  service_chance[cartwright] = 0.33;
  service_chance[porter] = 0.33;
  service_chance[saddler] = 0.16;
  service_chance[shipwright] = 0.16;
  service_chance[stable] = 0.5;
  service_chance[alchemist] = 0.05;
  service_chance[assassin] = 0.2;
  service_chance[astrologer] = 0.08;
  service_chance[barber] = 0.66;
  service_chance[barrister] = 0.08;
  service_chance[burgler] = 0.10;
  service_chance[dragoman] = 0.37;
  service_chance[engineer] = 0.08;
  service_chance[fence] = 0.5;
  service_chance[healer] = 0.33;
  service_chance[interpreter] = 0.2;
  service_chance[laborer] = 1;
  service_chance[leech] = 0.16;
  service_chance[linkboy] = 0.25;
  service_chance[minstrel] = 0.5;
  service_chance[navigator] = 0.25;
  service_chance[priest] = 0.66;
  service_chance[sage] = 0.08;
  service_chance[scribe] = 0.1;
  service_chance[wizard] = 0.25;

/*Reset chances based on city environment*/

  m = 0;
  q = 0;
  o = 0;
  p = 0;

  if (agg == 'y') {
     service_chance[grocer] = 0.1;
     ++m;
  }
  if (wine == 'y') {
     service_chance[vintner] = 0.5;
     ++m;
  }
  if (graze == 'y') {
     service_chance[leatherworker] = 1;
     service_chance[tanner] = 1;
     ++m;
  }
  if (hill == 'y') {
     service_chance[mason] = 1;
     ++m;
  }
  if (wood == 'y') {
     service_chance[bowyer] = 0.5;
     ++m;
  }
  if (port == 'n') {
     service_chance[navigator] = 0;
     if (river == 'n')
        service_chance[boatforhire] = 0;
  }
  if (port == 'y')
     ++q;
  if (river == 'y')
     ++q;

/*Test the service chance array
 *
 * i = 0;
 * for (i = 0; i < SERVICES; ++i) {
 *    printf("\n%s%d%s%f",
 *	    "Service Chance ", i, " is ", service_chance[i]);
 * }
 */

/*Determine city population block count, or village size*/

  pop_blocks = population / 500;
  v_size = 0;  
  village = 'n';

  if (pop_blocks == 0) {
     v_size = (float) population / 500;
     pop_blocks = 1;
     village = 'y';
  }

/*Test the pop block routine
 *
 * printf("\n\n%s%d", "population = ", population);
 * printf("\n\n%s%d", "pop_blocks = ", pop_blocks);
 * printf("\n\n%s%f", "v_size = ", v_size);
 * printf("\n\n%s%c", "village = ", village);
 */

/*Set the random number seed*/

  srandom(time(0) * getpid());

/*Now assign the services*/

  i = 0;
  j = 0;
  rand = 0;
  for (i = 0; i < SERVICES; ++i) {
     if (service_chance[i] == 0) {           /*Make sure chance isn't 0*/
        services[i] = 0;
     }

     else if (service_chance[i] != 1) {            /*Random percentages*/
        j = 0;
        for (j = 0; j < pop_blocks; ++j) {
	   rand = (float) random() / (float) 0x7fffffff;
	   if (rand <= service_chance[i])
	      ++services[i];
	}   
     }

     else if ((i == cobbler) || (i == woodworker) || (i == carter)) {    /*Random 1d2*/
        j = 0;
        for (j = 0; j < pop_blocks; ++j) {
	   rand = (float) random() / (float) 0x7fffffff;
	   rand = rand * 2;
	   if (rand <= 1)
	      ++services[i];
	   else
	      services[i] = services[i] + 2;
	}
     }
   
     else if ((i == tavern) || (i == blacksmith) || (i == tanner)) {     /*Random 1d3*/
        j = 0;
        for (j = 0; j < pop_blocks; ++j) {
	   rand = (float) random() / (float) 0x7fffffff;
	   rand = rand * 3;
	   if (rand <= 1)
	      ++services[i];
	   else if (rand <= 2)
	      services[i] = services[i] + 2;
	   else
	      services[i] = services[i] + 3;
	}
     }      

     else  {   /*Random 1d4*/
        j = 0;
        for (j = 0; j < pop_blocks; ++j) {
	   if (i == laborer)
	      ++services[i];
	   rand = (float) random() / (float) 0x7fffffff;
	   rand = rand * 4;
	   if (rand <= 1)
	      ++services[i];
	   else if (rand <= 2)
	      services[i] = services[i] + 2;
	   else if (rand <= 3)
	      services[i] = services[i] + 3;
	   else
	      services[i] = services[i] + 4;
	}
     }  
  }

/*Services assigned, now deal with villiages*/

  if (village == 'y') {
     i = 0;
     for (i = 0; i < SERVICES; ++i) {
        max = services[i];
	services[i] = 0;
	k = 0;
	for (k = 0; k < max; ++k) {
	   rand = (float) random() / (float) 0x7fffffff;
	   if (rand <= v_size)
	     ++services[i];
	}
     }
  }

  o = m;
  p = q;

/*
 *Services have been assigned, services[] array is now complete.
 *Now arrange the array to be printed.
 */  

  printf("\n%s\n\n%s\n%s\n%s", 
	 "City services have been successfully generated.",
	 "Would you like the data saved to a text file,",
	 "formated as an HTML file, or both?",
	 "Please enter t, h, or b: ");
  while ((c = getchar()) != '\n') {
    type = c;
  }
  if ((type == 'h') || (type == 'b')) {
      ofp = fopen("city.html", "w");          /*Open city.html for writing.*/
  
/*Begin writing the html file*/

      fprintf(ofp, "%s%s%s\n\n%s\n\n%s%s%s\n\n%s%d\n%s%s%s",
	      "<html><head><title>Services Available in ",
	      name,
	      "</title></head>",
	      "<body bgcolor=ffffff>",
	      "<h1>Services Available in ",
	      name,
	      "</h1>",
	      "<br>Population:  ", population,
	      "<p>", name, " is a ");

/*City description text*/

      if (population <= 250)
	 fprintf(ofp, "%s", "small village");
      else if (population <= 500)
	 fprintf(ofp, "%s", "village");
      else if (population <= 1500)
	 fprintf(ofp, "%s", "small town");
      else if (population <= 5000)
	 fprintf(ofp, "%s", "town");
      else if (population <= 7500)
	 fprintf(ofp, "%s", "small city");
      else if (population <= 15000)
	 fprintf(ofp, "%s", "city");
      else if (population <= 25000)
	 fprintf(ofp, "%s", "large city");
      else if (population <= 40000)
	 fprintf(ofp, "%s", "huge city");
      else
	 fprintf(ofp, "%s", "metropolis");

      while (m != 0) {
	 fprintf(ofp, "%s\n%s",
		 ",", " situated in ");
	 if (agg == 'y') {
	    fprintf(ofp, "%s", "an area of heavy agriculture");	    
	    --m;
	    if (wine == 'y') {
	       if (m == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "wine country");
	       --m;
	    }
	    if (hill == 'y') {
	       if (m == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "hills or mountains");
	       --m;
	    }
	    if (graze == 'y') {
	       if (m == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "an area of herding or grazing");
	       --m;
	    }
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --m;
	    }
	 }

	 else if (wine == 'y') {
	    fprintf(ofp, "%s", "wine country");
	    --m;
	    if (hill == 'y') {
	       if (m == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "hills or mountains");
	       --m;
	    }
	    if (graze == 'y') {
	       if (m == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "an area of herding or grazing");
	       --m;
	    }
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --m;
	    }
	 }

	 else if (hill == 'y') {
	    fprintf(ofp, "%s", "hills or mountains");
	    --m;
	    if (graze == 'y') {
	       if (m == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "an area of herding or grazing");
	       --m;
	    }
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --m;
	    }
	 }

	 else if (graze == 'y') {
	    fprintf(ofp, "%s", "an area of herding or grazing");
	    --m;
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --m;
	    }
	 }
	 else {
	    fprintf(ofp, "%s", "a forest or woodlands");
	    --m;
	 }
      }

      fprintf(ofp, "%s\n", ".");

      while (q != 0) {
	 fprintf(ofp, "%s", "<p>");
	 if (port == 'y') {
	    fprintf(ofp, "%s%s", name, " is a port");
	    --q;
	    if (river == 'n')
	       fprintf(ofp, "%s", ".");
	    else {
	       fprintf(ofp, "%s", " and along a river.");
	       --q;
	    }
	 }
	 else {
	    fprintf(ofp, "%s%s", name, " is along a river.");
	    --q;
	 }
      }

      fprintf(ofp, "\n%s%s%s", "<p>", name, " is approximately ");

      if (population <= 250)
	 fprintf(ofp, "%s", "10000 square yards in area, or a block about 100 yards on a side.");
      else if (population <= 500)
	 fprintf(ofp, "%s", "40000 square yards in area, or a block about 200 yards on a side.");
      else if (population <= 1500)
	 fprintf(ofp, "%s", "90000 square yards in area, or a block about 300 yards on a side.");
      else if (population <= 5000)
	 fprintf(ofp, "%s", "1/12 square mile in area, or a block about 500 yards on a side.");
      else if (population <= 7500)
	 fprintf(ofp, "%s", "1/8 square mile in area, or a block of about 600 yards on a side.");
      else if (population <= 15000)
	 fprintf(ofp, "%s", "1/4 square mile in area, or a block of about 900 yards on a side.");
      else if (population <= 25000)
	 fprintf(ofp, "%s", "1/2 square mile in area, or a block about 1200 yards on a side.");
      else if (population <= 40000)
	 fprintf(ofp, "%s", "1 square mile in area, or a block about 1800 yards on a side.");
      else if (population <= 60000)
	 fprintf(ofp, "%s", "1.5 square miles in area.");
      else if (population <= 80000)
	 fprintf(ofp, "%s", "2 square miles in area.");
      else if (population <= 120000)
	 fprintf(ofp, "%s", "3 square miles in area.");
      else if (population <= 160000)
	 fprintf(ofp, "%s", "4 square miles in area.");
      else if (population <= 200000)
	 fprintf(ofp, "%s", "5 square miles in area.");
      else if (population <= 240000)
	 fprintf(ofp, "%s", "6 square miles in area.");
      else if (population <= 280000)
	 fprintf(ofp, "%s", "7 square miles in area.");
      else if (population <= 320000)
	 fprintf(ofp, "%s", "8 square miles in area.");
      else
	 fprintf(ofp, "%s\n%s", "more than 8 square miles in area.", "<br>Are you sure you're playing AD&D?");

      fprintf(ofp, "%s\n%s\n%s\n%s\n%s\n%s\n",
	      "<p><table>",
	      "<tr><td width=50><u>Number</u></td><td><u>Resource or Service</u></td>",
	      "<td width=50></td>",
	      "<td width=50><u>Number</u></td><td><u>Resource or Service</u></td></tr>",
	      "<tr><th colspan=2>Food, Drink, and Lodging</th>",
	      "<td></td><th colspan=2>Transportation</th></tr>");

/*   printf("\n%s\n", "Block 1 done."); */

      fprintf(ofp, "%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n", 
	      "<tr><td>", services[0], "</td><td>Almshouse</td>",
	      "<td></td><td>", services[40], "</td><td>Boat for Hire</td></tr>",
	      "<tr><td>", services[1], "</td><td>Baker</td>",
	      "<td></td><td>", services[41], "</td><td>Carter / Teamster</td></tr>",
	      "<tr><td>", services[2], "</td><td>Boarding House</td>",
	      "<td></td><td>", services[42], "</td><td>Cartwright</td></tr>",
	      "<tr><td>", services[3], "</td><td>Brewer</td>",
	      "<td></td><td>", services[43], "</td><td>Porter</td></tr>",
	      "<tr><td>", services[4], "</td><td>Butcher</td>",
	      "<td></td><td>", services[44], "</td><td>Saddler</td></tr>",
	      "<tr><td>", services[5], "</td><td>Cheesemaker</td>",
	      "<td></td><td>", services[45], "</td><td>Shipwright</td></tr>",
	      "<tr><td>", services[6], "</td><td>Grocer</td>",
	      "<td></td><td>", services[46], "</td><td>Stable</td></tr>");

/*   printf("%s\n", "Block 2 done."); */

      fprintf(ofp, "%s%d%s\n%s%d%s\n%s%d%s\n%s%d%s\n%s%d%s\n", 
	      "<tr><td>", services[7], "</td><td>Hostel</td></tr>",
	      "<tr><td>", services[8], "</td><td>Inn</td></tr>",
	      "<tr><td>", services[9], "</td><td>Provisioner</td></tr>",
	      "<tr><td>", services[10], "</td><td>Tavern</td></tr>",
	      "<tr><td>", services[11], "</td><td>Vintner</td></tr>");

      fprintf(ofp, "%s\n", "<tr><td colspan=5><hr></td></tr>");

/*   printf("%s\n", "Block 3 done."); */

      fprintf(ofp, "%s\n%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n",
	      "<tr><th colspan=2>Common Crafts and Trades</th>",
	      "<td></td><th colspan=2>Rare Crafts and Trades</th></tr>",
	      "<tr><td>", services[12], "</td><td>Blacksmith</td>",
	      "<td></td><td>", services[23], "</td><td>Apothecary</td></tr>",
	      "<tr><td>", services[13], "</td><td>Trader / Merchant</td>",
	      "<td></td><td>", services[24], "</td><td>Armorer *</td></tr>",
	      "<tr><td>", services[14], "</td><td>Cobbler</td>",
	      "<td></td><td>", services[25], "</td><td>Bookbinder</td></tr>",
	      "<tr><td>", services[15], "</td><td>Cooper</td>",
	      "<td></td><td>", services[26], "</td><td>Bowyer / Fletcher</td></tr>",
	      "<tr><td>", services[16], "</td><td>Leatherworker *</td>",
	      "<td></td><td>", services[27], "</td><td>Clockmaker</td></tr>",
	      "<tr><td>", services[17], "</td><td>Mason *</td>",
	      "<td></td><td>", services[28], "</td><td>Chandler</td></tr>");

/*   printf("%s\n", "Block 4 done."); */

      fprintf(ofp, "%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n", 
	      "<tr><td>", services[18], "</td><td>Miller</td>",
	      "<td></td><td>", services[29], "</td><td>Dyer *</td></tr>",
	      "<tr><td>", services[19], "</td><td>Potter</td>",
	      "<td></td><td>", services[30], "</td><td>Fine Clothier</td></tr>",
	      "<tr><td>", services[20], "</td><td>Tanner *</td>",
	      "<td></td><td>", services[31], "</td><td>Furrier *</td></tr>",
	      "<tr><td>", services[21], "</td><td>Weaver *</td>",
	      "<td></td><td>", services[32], "</td><td>Glassblower / Glazier</td></tr>",
	      "<tr><td>", services[22], "</td><td>Woodworker</td>",
	      "<td></td><td>", services[33], "</td><td>Herbalist</td></tr>");

/*   printf("%s\n", "Block 5 done."); */

      fprintf(ofp, "%s%d%s\n%s%d%s\n%s%d%s\n%s%d%s\n%s%d%s\n%s%d%s\n%s\n", 
	      "<tr><td colspan=3></td><td>", services[34], "</td><td>Jeweler</td></tr>",
	      "<tr><td colspan=3></td><td>", services[35], "</td><td>Locksmith</td></tr>",
	      "<tr><td colspan=3></td><td>", services[36], "</td><td>Seamstress / Tailor</td></tr>",
	      "<tr><td colspan=3></td><td>", services[37], "</td><td>Specialty Smith *</td></tr>",
	      "<tr><td colspan=3></td><td>", services[38], "</td><td>Tilemaker *</td></tr>",
	      "<tr><td colspan=3></td><td>", services[39], "</td><td>Weaponsmith *</td></tr>",
              "<tr><td colspan=5>* May be major industry in town</td></tr>");

      fprintf(ofp, "%s\n", "<tr><td colspan=5><hr></td></tr>");

/*   printf("%s\n", "Block 6 done."); */

      fprintf(ofp, "%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n",
	      "<tr><th colspan=5>NPC Services</th></tr>",
	      "<tr><td>", services[47], "</td><td>Alchemist</td>",
	      "<td></td><td>", services[57], "</td><td>Interpreter</td></tr>",
	      "<tr><td>", services[48], "</td><td>Assassin / Bounty Hunter</td>",
	      "<td></td><td>", services[58], "</td><td>Laborer</td></tr>",
	      "<tr><td>", services[49], "</td><td>Astrologer</td>",
	      "<td></td><td>", services[59], "</td><td>Leech / Physician</td></tr>",
	      "<tr><td>", services[50], "</td><td>Barber</td>",
	      "<td></td><td>", services[60], "</td><td>Linkboy</td></tr>",
	      "<tr><td>", services[51], "</td><td>Barrister</td>",
	      "<td></td><td>", services[61], "</td><td>Minstrel / Entertainer</td></tr>",
	      "<tr><td>", services[52], "</td><td>Burgler</td>",
	      "<td></td><td>", services[62], "</td><td>Navigator</td></tr>",
	      "<tr><td>", services[53], "</td><td>Dragoman</td>",
	      "<td></td><td>", services[63], "</td><td>Priest</td></tr>");

/*   printf("%s\n", "Block 7 done."); */

      fprintf(ofp, "%s%d%s%s%d%s\n%s%d%s%s%d%s\n%s%d%s%s%d%s\n", 
	      "<tr><td>", services[54], "</td><td>Engineer</td>",
	      "<td></td><td>", services[64], "</td><td>Sage</td></tr>",
	      "<tr><td>", services[55], "</td><td>Fence</td>",
	      "<td></td><td>", services[65], "</td><td>Scribe / Clerk</td></tr>",
	      "<tr><td>", services[56], "</td><td>Healer</td>",
	      "<td></td><td>", services[66], "</td><td>Wizard</td></tr>");

      fprintf(ofp, "%s\n", "<tr><td colspan=5><hr></td></tr>");

/*   printf("%s\n", "Block 8 done."); */

      fprintf(ofp, "%s\n%s\n%s",
	      "</table>",
	      "</body>",
	      "</html>");
      fclose(ofp);                              /*Close city.html, writing finished.*/

      printf("\n%s",
	     "The data has been saved to the file 'city.html'.");
  }

  if (type != 'h') {
      ofp = fopen("city.txt", "w");          /*Open city.txt for writing.*/

/*Begin writing the text file*/

      fprintf(ofp, "%s%s\n\n%s%d\n%s%s",
	      "Services Available in ",
	      name,
	      "Population:  ", population,
	      name, " is a ");

/*City description text*/

      if (population <= 250)
	 fprintf(ofp, "%s", "small village");
      else if (population <= 500)
	 fprintf(ofp, "%s", "village");
      else if (population <= 1500)
	 fprintf(ofp, "%s", "small town");
      else if (population <= 5000)
	 fprintf(ofp, "%s", "town");
      else if (population <= 7500)
	 fprintf(ofp, "%s", "small city");
      else if (population <= 15000)
	 fprintf(ofp, "%s", "city");
      else if (population <= 25000)
	 fprintf(ofp, "%s", "large city");
      else if (population <= 40000)
	 fprintf(ofp, "%s", "huge city");
      else
	 fprintf(ofp, "%s", "metropolis");

      while (o != 0) {
	 fprintf(ofp, "%s%s",
		 ",", " situated in ");
	 if (agg == 'y') {
	    fprintf(ofp, "%s", "an area of heavy agriculture");	    
	    --o;
	    if (wine == 'y') {
	       if (o == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "wine country");
	       --o;
	    }
	    if (hill == 'y') {
	       if (o == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "hills or mountains");
	       --o;
	    }
	    if (graze == 'y') {
	       if (o == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "an area of herding or grazing");
	       --o;
	    }
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --o;
	    }
	 }

	 else if (wine == 'y') {
	    fprintf(ofp, "%s", "wine country");
	    --o;
	    if (hill == 'y') {
	       if (o == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "hills or mountains");
	       --o;
	    }
	    if (graze == 'y') {
	       if (o == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "an area of herding or grazing");
	       --o;
	    }
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --o;
	    }
	 }

	 else if (hill == 'y') {
	    fprintf(ofp, "%s", "hills or mountains");
	    --o;
	    if (graze == 'y') {
	       if (o == 1)
		  fprintf(ofp, "%s", ", and ");
	       else
		  fprintf(ofp, "%s", ", ");
	       fprintf(ofp, "%s", "an area of herding or grazing");
	       --o;
	    }
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --o;
	    }
	 }

	 else if (graze == 'y') {
	    fprintf(ofp, "%s", "an area of herding or grazing");
	    --o;
	    if (wood == 'y') {
	       fprintf(ofp, "%s", ", and ");
	       fprintf(ofp, "%s", "a forest or woodlands");
	       --o;
	    }
	 }
	 else {
	    fprintf(ofp, "%s", "a forest or woodlands");
	    --o;
	 }
      }

      fprintf(ofp, "%s\n", ".");

      while (p != 0) {
	 if (port == 'y') {
	    fprintf(ofp, "%s%s", name, " is a port");
	    --p;
	    if (river == 'n')
	       fprintf(ofp, "%s", ".");
	    else {
	       fprintf(ofp, "%s", " and along a river.");
	       --p;
	    }
	 }
	 else {
	    fprintf(ofp, "%s%s", name, " is along a river.");
	    --p;
	 }
      }

      fprintf(ofp, "\n%s%s", name, " is approximately ");

      if (population <= 250)
	 fprintf(ofp, "%s", "10000 square yards in area, or a block about 100 yards on a side.");
      else if (population <= 500)
	 fprintf(ofp, "%s", "40000 square yards in area, or a block about 200 yards on a side.");
      else if (population <= 1500)
	 fprintf(ofp, "%s", "90000 square yards in area, or a block about 300 yards on a side.");
      else if (population <= 5000)
	 fprintf(ofp, "%s", "1/12 square mile in area, or a block about 500 yards on a side.");
      else if (population <= 7500)
	 fprintf(ofp, "%s", "1/8 square mile in area, or a block of about 600 yards on a side.");
      else if (population <= 15000)
	 fprintf(ofp, "%s", "1/4 square mile in area, or a block of about 900 yards on a side.");
      else if (population <= 25000)
	 fprintf(ofp, "%s", "1/2 square mile in area, or a block about 1200 yards on a side.");
      else if (population <= 40000)
	 fprintf(ofp, "%s", "1 square mile in area, or a block about 1800 yards on a side.");
      else if (population <= 60000)
	 fprintf(ofp, "%s", "1.5 square miles in area.");
      else if (population <= 80000)
	 fprintf(ofp, "%s", "2 square miles in area.");
      else if (population <= 120000)
	 fprintf(ofp, "%s", "3 square miles in area.");
      else if (population <= 160000)
	 fprintf(ofp, "%s", "4 square miles in area.");
      else if (population <= 200000)
	 fprintf(ofp, "%s", "5 square miles in area.");
      else if (population <= 240000)
	 fprintf(ofp, "%s", "6 square miles in area.");
      else if (population <= 280000)
	 fprintf(ofp, "%s", "7 square miles in area.");
      else if (population <= 320000)
	 fprintf(ofp, "%s", "8 square miles in area.");
      else
	 fprintf(ofp, "%s\n%s", "more than 8 square miles in area.", "Are you sure you're playing AD&D?");

      fprintf(ofp, "\n\n%s\t%s\t\t%s\t%s\n%s\t\t%s\n",
	      "Number",
              "Resource or Service",
	      "Number",
	      "Resource or Service",
	      " Food, Drink, and Lodging",
	      " Transportation");

/*   printf("\n%s\n", "Block 1 done."); */

      fprintf(ofp, "%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n",
	      services[0], "Almshouse",
	      services[40], "Boat for Hire",
	      services[1], "Baker",
	      services[41], "Carter / Teamster",
	      services[2], "Boarding House",
	      services[42], "Cartwright",
	      services[3], "Brewer",
	      services[43], "Porter",
	      services[4], "Butcher",
	      services[44], "Saddler",
	      services[5], "Cheesemaker",
	      services[45], "Shipwright",
	      services[6], "Grocer",
	      services[46], "Stable");

/*   printf("%s\n", "Block 2 done."); */

      fprintf(ofp, "%d\t%s\n%d\t%s\n%d\t%s\n%d\t%s\n%d\t%s\n",
	      services[7], "Hostel",
	      services[8], "Inn",
	      services[9], "Provisioner",
	      services[10], "Tavern",
	      services[11], "Vintner");

      fprintf(ofp, "\n\n%s\n\n", "-------------------------------------------------------------------");

/*   printf("%s\n", "Block 3 done."); */

      fprintf(ofp, "%s\t\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n",
	      " Common Crafts and Trades",
	      " Rare Crafts and Trades",
	      services[12], "Blacksmith",
	      services[23], "Apothecary",
	      services[13], "Trader / Merchant",
	      services[24], "Armorer *",
	      services[14], "Cobbler",
	      services[25], "Bookbinder",
	      services[15], "Cooper",
	      services[26], "Bowyer / Fletcher",
	      services[16], "Leatherworker *",
	      services[27], "Clockmaker",
	      services[17], "Mason *",
	      services[28], "Chandler");

/*   printf("%s\n", "Block 4 done."); */

      fprintf(ofp, "%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n",
	      services[18], "Miller",
	      services[29], "Dyer *",
	      services[19], "Potter",
	      services[30], "Fine Clothier",
	      services[20], "Tanner *",
	      services[31], "Furrier *",
	      services[21], "Weaver *",
	      services[32], "Glassblower / Glazier",
	      services[22], "Woodworker",
	      services[33], "Herbalist");

/*   printf("%s\n", "Block 5 done."); */

      fprintf(ofp, "\t\t\t\t\t%d\t%s\n\t\t\t\t\t%d\t%s\n\t\t\t\t\t%d\t%s\n\t\t\t\t\t%d\t%s\n\t\t\t\t\t%d\t%s\n\t\t\t\t\t%d\t%s\n\n%s",
	      services[34], "Jeweler",
	      services[35], "Locksmith",
	      services[36], "Seamstress / Tailor",
	      services[37], "Specialty Smith *",
	      services[38], "Tilemaker *",
	      services[39], "Weaponsmith *",
              "* May be major industry in town");

      fprintf(ofp, "\n\n%s\n\n", "-------------------------------------------------------------------");

/*   printf("%s\n", "Block 6 done."); */

      fprintf(ofp, "\t\t\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t%d\t%s\n",
	      "   NPC Services",
	      services[47], "Alchemist",
	      services[57], "Interpreter",
	      services[48], "Assassin / Bounty Hunter",
	      services[58], "Laborer",
	      services[49], "Astrologer",
	      services[59], "Leech / Physician",
	      services[50], "Barber",
	      services[60], "Linkboy",
	      services[51], "Barrister",
	      services[61], "Minstrel / Entertainer",
	      services[52], "Burgler",
	      services[62], "Navigator",
	      services[53], "Dragoman",
	      services[63], "Priest");

/*   printf("%s\n", "Block 7 done."); */

      fprintf(ofp, "%d\t%s\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n%d\t%s\t\t\t\t%d\t%s\n",
	      services[54], "Engineer",
	      services[64], "Sage",
	      services[55], "Fence",
	      services[65], "Scribe / Clerk",
	      services[56], "Healer",
	      services[66], "Wizard");

      fprintf(ofp, "\n\n%s\n\n", "-------------------------------------------------------------------");

/*   printf("%s\n", "Block 8 done."); */

      printf("\n%s\n", "The data has been saved to the file 'city.txt'.");
      fclose(ofp);                           /*Close city.txt, writing finished.*/
  }

  printf("\n%s\n%s\n",
	 "Thankyou for using John's City Services Generation Program.",
	 "Have a nice day.");
  return 0;
}
